/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "check.h"
#include "dict.h"
#include "builtin_dict.h"

// ****************************************************************************
// 
// ****************************************************************************
#include "data/wordle.i"

#ifndef WORDLE_I

static word list0 = { { "cigar" } };
static word list1 = { { "aahed" } };

#endif

#define LIST0_SIZE	(sizeof(list0) / sizeof(word))
#define LIST1_SIZE	(sizeof(list1) / sizeof(word))

static const dict dict_sol = { LIST0_SIZE, 0, list0 };
static const dict dict_add = { LIST1_SIZE, 0, list1 };

void dict_builtin_solutions(dict *d)
{
	dict_reset(d);
	dict_append_dict(d, &dict_sol);
	dict_sort(d);
}

void dict_builtin_additional(dict *d)
{
	dict_reset(d);
	dict_append_dict(d, &dict_add);
	dict_sort(d);
}

void dict_builtin_full(dict *d)
{
	dict_reset(d);
	dict_append_dict(d, &dict_sol);
	dict_append_dict(d, &dict_add);
	dict_sort(d);
	
	check(d->count, ==, DICT_SIZE);
}

// ****************************************************************************
// 
// ****************************************************************************


