/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef CHECK_H
#define CHECK_H
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>

// ****************************************************************************
// 
// ****************************************************************************
#define check_s(a, rel, b, ...) \
	do { \
		if (((a) rel (b))) \
			break; \
		fprintf(stderr, "%s:%d: %s(): assertion failed:\n" \
			"\t" #a " " #rel " " #b "\n" \
			"\t%zd " #rel " %zd\n", \
			__FILE__, __LINE__, __func__, \
			(ssize_t)(a), (ssize_t)(b)); \
		fprintf(stderr, __VA_ARGS__); \
		exit(1); \
	} while (0)

#define check(a, rel, b)	check_s(a, rel, b, "\n")

// ****************************************************************************
// 
// ****************************************************************************

#endif

