/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef PLAY_H
#define PLAY_H
#include <stdint.h>
#include <stdio.h>
#include "lookup.h"
#include "dict.h"


// ****************************************************************************
// 
// ****************************************************************************
#define PLAY_MAX	256

typedef struct game_t {
	int flags;
	word target;
	dict_index target_index;
	
	dict allow;
	lut *table;
	
	int round;
	word prev_g;
	hash_index prev_h;
	lset green, yellow, gray;
	
	dict_index hist_g[PLAY_MAX];
	hash_index hist_h[PLAY_MAX];
	int hist_l;
} game;

void game_init(game *g, int flags);
void game_reset(game *g);
void game_clear(game *g);

void game_set_word(game *g, const char *s);
void game_set_random(game *g);

void game_interactive(game *g);



#endif
