/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef SOLVE_H
#define SOLVE_H
#include "tree.h"

typedef struct solver_t {
	int flags;
	
	node_index root;
	node_index size;
	node_index current;
	
	dict d;
	node *node_buffer;
} solver;

void solver_init(solver *s, int flags);
void solver_reset(solver *s);
void solver_clear(solver *s);

node_index solver_advise(solver *s);
int solver_next(solver *s, hash_index h);

void solver_interactive(solver *s);
void solver_all(solver *s);
int solver_connectivity(solver *s);

void solver_export_js(int flags);
void solver_export_txt(int flags);


#endif
