/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef TREE_H
#define TREE_H
#include <stdint.h>
#include <stdio.h>
#include "constants.h"
#include "dict.h"

typedef uint8_t depth_index;
#define DEPTH_INF		((depth_index)50)

typedef size_t node_index;
#define NODE_NONE		((node_index)-1)

typedef struct tree_t tree;



tree *tree_build(size_t thread_id, size_t thread_total,
	depth_index global_depth_ub,
	dict_index fast_k, dict_index fast_c, size_t prog_i, int flags);

void tree_free(tree *t);



typedef struct node_t {
	hash_index hash;
	depth_index depth;
	dict_index guess;
	
	node_index child, sibling;
} node;


void tree_get(tree *t,
	node_index *count_r, node_index *root_r, node **nodes_r);

#endif
