/*
    This file is part of Wordle Solver.
    Copyright (C) 2022  Laurent Poirrier

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published
    by the Free Software Foundation, version 3 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "word.h"

// ****************************************************************************
// 
// ****************************************************************************
word word_build(const char *s)
{
	word w = word_zero();
	
	__builtin_memcpy(w.s, s, LENGTH);
	
	return w;
}

word word_fix(const char *fix)
{
	word f = word_zero();
	
	for (size_t j = 0; j < LENGTH; j++) {
		f.s[j] = (fix[j] == ' ') ? 0 : fix[j];
	}
	
	return f;
}

word word_lower(word w)
{
	for (size_t j = 0; j < LENGTH; j++) {
		char c = w.s[j];
		if ((c >= 'A') && (c <= 'Z')) {
			w.s[j] = c - 'A' + 'a';
		}
	}
	
	return w;
}

int word_letters(const word w)
{
	int r = 1;
	
	for (size_t j = 0; j < LENGTH; j++) {
		int c = w.s[j];
		
		r &= ((c >= 'a') && (c <= 'z'));
	}
	
	return r;
}


// ****************************************************************************
// 
// ****************************************************************************
